package me.zhanshi123.tutorialitemdemo;

import it.unimi.dsi.fastutil.Hash;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import com.neteasemc.spigotmaster.SpigotMaster;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;


public class Listeners implements Listener {

    private SpigotMaster spigotMaster = (SpigotMaster) Bukkit.getPluginManager().getPlugin("SpigotMaster");

    @EventHandler
    public void onInteract(PlayerInteractEvent e) {
        Action action = e.getAction();
        if (action != Action.RIGHT_CLICK_BLOCK && action != Action.RIGHT_CLICK_AIR) {
            return;
        }
        ItemStack itemStack = e.getItem();
        String identifier = spigotMaster.getCustomItemIdentifier(itemStack);
        Player player = e.getPlayer();
        if (identifier.equalsIgnoreCase("testitem:item1")) {
            sendEffect(player);
        } else if (identifier.equalsIgnoreCase("testitem:item2")) {
            changeModel(player);
        }
    }

    private void sendEffect(Player player) {
        Map<String, Object> data = new HashMap<>();
        data.put("name", "effects/Attack_2.json");
        Location location = player.getLocation();
        data.put("pos", Arrays.asList(location.getX(), location.getY(), location.getZ()));
        spigotMaster.notifyToClient(player, "testEffects", "testEffectsDev", "PlayEffectEvent", data);
    }

    private void changeModel(Player player) {
        spigotMaster.notifyToClient(player, "testModel", "testModelDev", "OnChangeLocalModelEvent", new HashMap<>());
    }
}
